/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietUK;

public abstract class AbstractWahlbeteiligungVerlaufGebietDAO extends de.ivu.elect.jee.entity.AbstractDAO<WahlbeteiligungVerlaufGebiet,
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK
    , WahlbeteiligungVerlaufGebietUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractWahlbeteiligungVerlaufGebietDAO.class);

  public AbstractWahlbeteiligungVerlaufGebietDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public WahlbeteiligungVerlaufGebiet findByPrimaryKey(
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected WahlbeteiligungVerlaufGebiet findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(WahlbeteiligungVerlaufGebiet.class, id);
  }





  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietUK uk,
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet findByUK(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietUK uk){

    try {
     return (de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet) getEntityManager().createNamedQuery("WAHLBETEILIGUNG_VERLAUF_GEBIET.UK")
                  .setParameter(1, uk
                .getGebietUK ()  
                .getNummer ()  
              )
             .setParameter(2, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getName ()  
              )
             .setParameter(3, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(4, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(5, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(6, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(7, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(8, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(9, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(10, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(11, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(12, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getDatum ()   , javax.persistence.TemporalType.TIMESTAMP /*ELECT-13069*/ 
              )
             .setParameter(13, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getName ()  
              )
             .setParameter(14, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(15, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(16, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(17, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(18, uk
                .getWahlbeteiligungVerlaufUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("WahlbeteiligungVerlaufGebiet, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}